import { createRoot } from './react-dom-client';
class ReactHTMLElement extends HTMLElement {
    getShadowRoot() {
        return this.shadowRoot || this.attachShadow({ mode: 'open' });
    }
    get shadow() {
        if (this._initialized)
            return this.getShadowRoot();
        const shadow = this.getShadowRoot();
        shadow.innerHTML = this.template;
        this._initialized = true;
        return shadow;
    }
    get mountPoint() {
        if (this._mountPoint)
            return this._mountPoint;
        this._mountPoint = this.shadow.querySelector(this.mountSelector);
        return this._mountPoint;
    }
    set mountPoint(mount) {
        this._mountPoint = mount;
    }
    root() {
        if (this._root)
            return this._root;
        this._root = createRoot(this.mountPoint);
        return this._root;
    }
    render(app) {
        if (!this.isConnected)
            return;
        void this.renderRoot(app);
    }
    renderRoot(app) {
        const root = this.root();
        root.render(app);
    }
    disconnectedCallback() {
        var _a;
        if (!this._mountPoint)
            return;
        (_a = this._root) === null || _a === void 0 ? void 0 : _a.unmount();
    }
    constructor(template = '<div></div>', mountSelector = 'div') {
        super();
        this.template = template;
        this.mountSelector = mountSelector;
    }
}
export default ReactHTMLElement;
